; ### VICrossroads ###
; Port of the C64 game Crossroads for VIC-20.
; For 8k+.

; $033c - $03ff : variables
; $1000 - $17ff : charset
; $1201 - $xxxx : basic start
; $1600 - $xxxx : ml entry, phase 0 init code
; $1800 - $19ff : vmatrix, phase 1 init code
; $1axx - $xxxx : main code, data
; $3000 - $3fff : large data tables


; # const

DEBUG_IRQ_LEN = 0
DEBUG_OVERLAP = 0

; 0: normal idle screen
; 1: wait for joy up
; 2: wait for joy up/down (alternating)
DEBUG_IDLE_WAIT_INPUT = 0

EXPR_BOUNCE_OVERLAP_FIX = 0

NUM_OBJS = $100

OBJ_DATA_LEN = 10
OP_LDA_ABS_X = $bd
OP_STA_ABS_X = $9d

COLS = 21
ROWS = 21

AREA_W = 21
AREA_H = 20
AREA_YOFF = 1
LEVEL_SIZE = ((AREA_W * AREA_H + 7) / 8)

MONMUL = 1
MONDIV = 2

MAX_EXTRA_SHIELDS = 5

CHAR_EMPTY = $20
CHAR_SHIELD = $3f

SOUND_BOUNCE = 1    ; random, saw
SOUND_2 = 2    ; random, noise
SOUND_3 = 3    ; random, tri, low
SOUND_SHIELD = 4    ; random, tri, med
SOUND_PLAYER_SHOOT = 5  ; saw, descend
SOUND_SPAWN = 6 ; noise, descend
SOUND_7 = 7 ; noise, descend, high


; # addr

rng0 = $00
rng1 = $01
tmp_02 = $02
tmp_03 = $03
tmp_04 = $04
tmp_05 = $05
tmp_06 = $06
tmp_07 = $07
tmp_08 = $08
l0009 = $09
l000a = $0a
l000b = $0b
tmp_obj_index = $0d
tmp_0e = $0e
l000f = $0f
num_lives_p1 = $11
num_lives_p2 = $12
tmp_obj_index2 = $13
num_hits_p1 = $14
num_hits_p2 = $15
tbl_player_move_delay_counter = $16
tbl_player_fire_delay_counter = $18
obj_tbl_slot_prev = $39
tmp_3a = $3a
jiffy_lsb = $a2
key_code = $cb
tmp_fb = $fb
tmp_fc = $fc
tmp_fd = $fd
l00fe = $fe

kv_screen  = $288
kv_repeat  = $28a
kv_mode    = $291

charset = $1000
vmatrix = $1800
charset_gfx = charset + $200
charset_gfx_walls = charset + $1d8
charset_gfx_star = charset + $1f8

screen_num_players = vmatrix + 18
screen_pl2_input = vmatrix + 20
screen_loc_press_f7 = vmatrix + 1 * COLS + 12
colorram_loc_press_f7 = screen_loc_press_f7 + (colorram - vmatrix)
screen_loc_game_over = vmatrix + 1 * COLS + 1
colorram_loc_game_over = screen_loc_game_over + (colorram - vmatrix)
screen_p1_score = vmatrix + 0
screen_p1_lives = vmatrix + 6
screen_p1_shield = vmatrix + 7
screen_p2_score = vmatrix + 13
screen_p2_lives = vmatrix + 19
screen_p2_shield = vmatrix + 20
screen_level_h = vmatrix + 10
screen_level_l = vmatrix + 11
screen_high_score = vmatrix + 11

charset_rom = $8000
colorram = $9400 + (vmatrix & $200)

b_strout_ay = $cb1e
k_tbl_keycode = $ec5e

Data_start = $033c  ; cassette buffer

tbl_screen_line_addr_l = Data_start
tbl_screen_line_addr_h = Data_start + ROWS
p1_score_bcd = tbl_screen_line_addr_h + ROWS
tbl_player_score_bcd_10p4 = p1_score_bcd + 1
tbl_player_score_bcd_10p3 = p1_score_bcd + 2
tbl_player_score_bcd_10p2 = p1_score_bcd + 3
tbl_player_score_bcd_10p1 = p1_score_bcd + 4
tbl_player_score_bcd_10p0 = p1_score_bcd + 5
p2_score_bcd = p1_score_bcd + 6
num_level_bcd_h = p2_score_bcd + 6
num_level_bcd_l = num_level_bcd_h + 1
high_score_bcd = num_level_bcd_l + 1
spawn_delay_counter = high_score_bcd + 9
flag_pause = spawn_delay_counter + 1
tbl_ai_dir_obj_char = flag_pause + 1
tbl_ai_dir_obj_dist = tbl_ai_dir_obj_char + 4
tbl_ai_dir_obj_color = tbl_ai_dir_obj_dist + 4
tbl_ai_dir_weight = tbl_ai_dir_obj_color + 4
flag_move_bullets = tbl_ai_dir_weight + 4
flag_player_input = flag_move_bullets + 1
tbl_monster_num = flag_player_input + 1
player_input = tbl_monster_num + 10
largest_obj_tbl_slot = player_input + 2
player_input_delay_counter = largest_obj_tbl_slot + 1
move_bullets_delay_counter = player_input_delay_counter + 1
tbl_obj_slot_to_draw = move_bullets_delay_counter + 2
l3fb6 = tbl_obj_slot_to_draw + 8
num_level = l3fb6 + 1
tbl_ai_dir_fire = num_level + 4
star_anim_frame = tbl_ai_dir_fire + 4
counter_star_anim = star_anim_frame + 1
counter_skip_obj_update = counter_star_anim + 1
counter_title_scroll = counter_skip_obj_update + 1
counter_delay_jiffy = counter_title_scroll + 1
prev_rand_level = counter_delay_jiffy + 1
color_wall = prev_rand_level + 1
char_wall = color_wall + 1
flag_levelset = char_wall + 1
tbl_sound_fx = flag_levelset + 1
sound_fx_ch2 = tbl_sound_fx + 1
sound_fx_ch3 = tbl_sound_fx + 2
sound_fx_ch4 = tbl_sound_fx + 3
tbl_sound_state_counter = sound_fx_ch4 + 1
irq_sound_freq = tbl_sound_state_counter + 4
irq_sound_loop_counter = irq_sound_freq + 1
num_extra_shields = irq_sound_loop_counter + 1
tbl_player_input = num_extra_shields + 1
flag_pl2_userport_joy = tbl_player_input + 2
old_num_players = flag_pl2_userport_joy + 1
Data_end = old_num_players + 1
!if Data_end > $400 {
!error "data goes over $400"
}

Data_large_start = $3000

tbl_obj_char = Data_large_start + NUM_OBJS * 0
tbl_bullet = Data_large_start + NUM_OBJS * 1
tbl_obj_color = Data_large_start + NUM_OBJS * 2
tbl_obj_pos_x_frac = Data_large_start + NUM_OBJS * 3
tbl_obj_score_bcd_10p0 = Data_large_start + NUM_OBJS * 4
tbl_obj_score_bcd_10p1 = Data_large_start + NUM_OBJS * 5
tbl_obj_score_bcd_10p2 = Data_large_start + NUM_OBJS * 6
tbl_hits = Data_large_start + NUM_OBJS * 7
num_p2_hits = Data_large_start + NUM_OBJS * 7 + 1
tbl_obj_delay_value = Data_large_start + NUM_OBJS * 8
tbl_obj_vision = Data_large_start + NUM_OBJS * 9
tbl_obj_delay_counter = Data_large_start + NUM_OBJS * 10
tbl_pos_x = Data_large_start + NUM_OBJS * 11
tbl_pos_y = Data_large_start + NUM_OBJS * 12
tbl_shields = Data_large_start + NUM_OBJS * 13
num_p2_shields = Data_large_start + NUM_OBJS * 13 + 1
tbl_dir_udrl = Data_large_start + NUM_OBJS * 14
tbl_ms4b = Data_large_start + NUM_OBJS * 15


; # code

* = $1600

!zn Phase0_Init {   ; all within the zone can be overwritten after run once

; # p0 code
Init_phase0:
    sei
    ldx #$ff
    txs
    cld
    lda #$7f
    sta $913d
    sta $913e

    ; build X>>4 table
    ldx #0
-   txa
    lsr
    lsr
    lsr
    lsr
    sta tbl_ms4b,x
    inx
    bne -

    lda #$31
    sta old_num_players
    lda #0
    sta flag_pl2_userport_joy
    sta star_anim_frame
    sta spawn_delay_counter
    lda #1
    sta player_input_delay_counter
    sta move_bullets_delay_counter
    sta counter_star_anim
    sta counter_skip_obj_update
    sta counter_title_scroll
    sta flag_pause

    lda jiffy_lsb
    ora #$55
    sta rng0

    ldx #$07
    lda #$00
-   sta high_score_bcd,x
    dex
    bpl -
    ldx #$03
-   sta tbl_sound_fx,x
    dex
    bpl -
    ldx #>vmatrix
    tay
init_tbl_screen_line_addr:
    sta tbl_screen_line_addr_l,y
    pha
    txa
    sta tbl_screen_line_addr_h,y
    iny
    cpy #ROWS
    beq +
    pla
    clc
    adc #COLS
    bcc init_tbl_screen_line_addr
    inx
    bcs init_tbl_screen_line_addr
+

    ; initialize VIC/VIA
    ldx #$f
-   lda gamefw_tv_tbl_vic,x
    sta $9000,x
    dex
    bpl -
    lda #0
    ldx #$a
-   sta $9132,x
    dex
    bpl -

    ; detect pal/ntsc
    lda $ede4
    and #$01
    tax ; 0 -> pal, 1 -> ntsc
    beq +
    lda #5
    sta $9000
    lda #26
    sta $9001
+
    lda #>vmatrix
    sta kv_screen
    lda #$00
    sta kv_repeat
    lda #$80
    sta kv_mode

    lda #$40
    sta $912b       ; enable Timer A free run on VIA 1
    lda #<irq       ; set the raster IRQ routine pointer
    sta $0314
    lda #>irq
    sta $0315
    lda #<nmi
    sta $0316
    lda #>nmi
    sta $0317

    lda gamefw_tv_tbl_raster,x
    pha
    lda gamefw_tv_tbl_timer_l,x
    tay
    lda gamefw_tv_tbl_timer_h,x
    tax
    ; synchronise with the screen
    pla
-   cmp $9004
    beq -
-   cmp $9004
    bne -

    sty $9126
    stx $9125

    lda #$c0
    cli
    sta $912e
    jmp init_phase1

; # p0 data

gamefw_tv_tbl_vic:
!by 12, 37, 0, 21 << 1, 0
!by ((((vmatrix & $1c00) >> 10) | ((vmatrix & $8000) >> 12) XOR 8) << 4) | (((charset & $1c00) >> 10) | ((charset & $8000) >> 12) XOR 8)
!by 0, 0, 0, 0
!by 0, 0, 0, 0
!by 0, 8

; tbl: index 0 -> pal, 1 -> ntsc
gamefw_tv_tbl_raster:
!by 131, 118
gamefw_tv_tbl_timer_l:
!by <(312 * 71 - 2), <(261 * 65 - 2)
gamefw_tv_tbl_timer_h:
!by >(312 * 71 - 2), >(261 * 65 - 2)

IP0_End = *
} ; !zn Phase0_Init

!if * > vmatrix {
!error "init phase 0 over vmatrix"
}

* = vmatrix

!zn Phase1_Init {   ; all within the zone can be overwritten after run once

; # p1 data

gfx_chars_src:
!by %........
!by %........
!by %.#...#..
!by %#.#.#.#.
!by %#.#.#.#.
!by %...#...#
!by %........
!by %........

!by %........
!by %........
!by %...#...#
!by %#.#.#.#.
!by %#.#.#.#.
!by %.#...#..
!by %........
!by %........

!by %........
!by %........
!by %........
!by %..####..
!by %..####..
!by %........
!by %........
!by %........

!by %........
!by %........
!by %........
!by %..####..
!by %..####..
!by %........
!by %........
!by %........

!by %..###...
!by %..###...
!by %..##....
!by %.#######
!by %#.#####.
!by %.##.#...
!by %##..###.
!by %###.##..

!by %..###...
!by %..###...
!by %..##....
!by %.#######
!by %.###.##.
!by %..##....
!by %..##....
!by %..###...

!by %########
!by %#...####
!by %########
!by %..####..
!by %.######.
!by %.######.
!by %###.###.
!by %#....###

!by %########
!by %####...#
!by %########
!by %..####..
!by %.######.
!by %.######.
!by %..###...
!by %..####..

!by %##...###
!by %#...##.#
!by %#.######
!by %######..
!by %########
!by %###.##..
!by %##...##.
!by %##....##

!by %..#..###
!by %.##.##.#
!by %#..#####
!by %########
!by %..######
!by %..####..
!by %..##....
!by %..###...

!by %..####..
!by %.###..#.
!by %########
!by %####....
!by %.######.
!by %...###..
!by %.##..##.
!by %.###..##

!by %..####..
!by %.###..#.
!by %########
!by %#####...
!by %.######.
!by %...#....
!by %...#....
!by %...##...

!by %.######.
!by %##..####
!by %#####...
!by %####....
!by %#####...
!by %.#######
!by %###..##.
!by %#....###

!by %..######
!by %##..####
!by %########
!by %####....
!by %########
!by %.#######
!by %..##....
!by %..###...

!by %.#####..
!by %.##.##..
!by %########
!by %####....
!by %####....
!by %########
!by %#....#..
!by %###..###

!by %.#####..
!by %.##.##..
!by %########
!by %#####.#.
!by %####.#.#
!by %########
!by %...##...
!by %...###..

!by %###.....
!by %#...####
!by %#...#..#
!by %########
!by %######..
!by %########
!by %##....#.
!by %#.....##

!by %..#.....
!by %###.####
!by %#...#..#
!by %########
!by %#####...
!by %########
!by %.#..##..
!by %.##.#...

!by %...##...
!by %..#####.
!by %.####...
!by %########
!by %########
!by %.##.##..
!by %##...##.
!by %.##..###

!by %...##...
!by %..#####.
!by %.####...
!by %########
!by %########
!by %..###...
!by %..###...
!by %..####..

!by %..####..
!by %..###...
!by %..####..
!by %.#######
!by %#.####..
!by %..####..
!by %.###.###
!by %.##..#..

!by %..####..
!by %..###...
!by %..####..
!by %.#####..
!by %.#####..
!by %..####..
!by %...##...
!by %...###..

!by %........
!by %........
!by %..####..
!by %#.###..#
!by %#######.
!by %.#####..
!by %.#...#..
!by %.##..##.

!by %..####..
!by %..###...
!by %.####...
!by %########
!by %.##.##..
!by %.#..#...
!by %........
!by %........

gfx_walls_src:
!by %.######.
!by %########
!by %########
!by %########
!by %########
!by %########
!by %########
!by %.######.

!by %########
!by %#......#
!by %#......#
!by %#......#
!by %#......#
!by %#......#
!by %#......#
!by %########

!by %########
!by %########
!by %#.####.#
!by %#..##..#
!by %#..##..#
!by %#.####.#
!by %########
!by %########

!by %..####..
!by %###..###
!by %#.####.#
!by %.##..##.
!by %.##..##.
!by %#.####.#
!by %###..###
!by %..####..

; # p1 code

init_phase1:
    ldx #$00
copy_charset_rom_loop:
    lda charset_rom,x
    sta charset,x
    lda charset_rom + $ec,x
    sta charset + $ec,x
    inx
    cpx #$ec
    bne copy_charset_rom_loop

; the charset has 16 chars per object:
; { frame 0, half-char 0, half-char 1, frame 1 }
; for the directions right, left, down, up.
; the half-char 0 is the "tail" part;
; IOW the half-char 1 is drawn to position + movement direction
    lda #<(charset_gfx - $80)
    sta sta_smc_x_l
    lda #>(charset_gfx - $80)
    sta sta_smc_x_h
    lda #$0b
    sta tmp_02
copy_charset_obj_loop:
    lda sta_smc_x_l
    bpl l0a34
    inc sta_smc_x_h
l0a34:
    clc
    adc #$80
    sta sta_smc_x_l
    lda #$00
    tax
l0a3d:
    jsr sta_smc_x
    inx
    cpx #$80
    bne l0a3d
    lda tmp_02
    asl
    asl
    asl
    asl
    tay
    ldx #$00
copy_charset_obj_direct_loop:
    lda gfx_chars_src,y
    jsr sta_smc_x
    iny
    inx
    cpx #$08
    bne copy_charset_obj_direct_loop
copy_charset_obj_shr_loop:
    lda gfx_chars_src,y
    lsr
    lsr
    lsr
    lsr
    jsr sta_smc_x
    inx
    iny
    cpx #$10
    bne copy_charset_obj_shr_loop
copy_charset_obj_shl_loop:
    lda gfx_chars_src - 8,y
    asl
    asl
    asl
    asl
    jsr sta_smc_x
    inx
    iny
    cpx #$18
    bne copy_charset_obj_shl_loop
l0a7a:
    lda gfx_chars_src - 16,y
    jsr sta_smc_x
    inx
    iny
    cpx #$20
    bne l0a7a
    jsr build_reverse_charset_obj
    ldy #$00
    ldx #$40
    jsr build_reverse_charset_obj2
    ldy #$20
    ldx #$60
    jsr build_reverse_charset_obj2
    dec tmp_02
    bpl copy_charset_obj_loop
copy_charset_walls:
    ldx #$1f
copy_charset_walls_loop:
    lda gfx_walls_src,x
    sta charset_gfx_walls,x
    dex
    bpl copy_charset_walls_loop
    jmp init_phase2
build_reverse_charset_obj:
    lda #$00
    sta tmp_fc
build_reverse_charset_obj_loop:
    txa
    sec
    sbc #$20
    tay
    jsr lda_smc_y_from_smc_x
    ldy tmp_fc
    and tbl_bitmask_rev,y
    cmp tbl_bitmask_rev,y
    bne l0acd
    txa
    tay
    jsr lda_smc_y_from_smc_x
    ldy tmp_fc
    clc
    adc tbl_bitmask,y
    jsr sta_smc_x
l0acd:
    iny
    sty tmp_fc
    cpy #$08
    bne build_reverse_charset_obj_loop
    inx
    cpx #$40
    bne build_reverse_charset_obj
    rts
build_reverse_charset_obj2:
    stx tmp_fc
    sty tmp_fd
    lda #$04
    sta tmp_fb
build_reverse_charset_obj2_loop:
    lda #$00
    sta tmp_03
build_reverse_charset_obj2_loop2:
    lda #$00
    sta l00fe
build_reverse_charset_obj2_loop3:
    lda l00fe
    clc
    adc tmp_fd
    tay
    jsr lda_smc_y_from_smc_x
    ldx tmp_03
    and tbl_bitmask_rev,x
    cmp tbl_bitmask_rev,x
    bne l0b13
    lda tmp_03
    clc
    adc tmp_fc
    tay
    jsr lda_smc_y_from_smc_x
    clc
    ldx l00fe
    adc tbl_bitmask,x
    pha
    tya
    tax
    pla
    jsr sta_smc_x
l0b13:
    inc l00fe
    lda l00fe
    cmp #$08
    bne build_reverse_charset_obj2_loop3
    inc tmp_03
    lda tmp_03
    cmp #$08
    bne build_reverse_charset_obj2_loop2
    lda tmp_fc
    clc
    adc #$08
    sta tmp_fc
    lda tmp_fd
    clc
    adc #$08
    sta tmp_fd
    dec tmp_fb
    bne build_reverse_charset_obj2_loop
    rts
sta_smc_x:
sta_smc_x_l = * + 1
sta_smc_x_h = * + 2
    sta $ffff,x
    rts
lda_smc_y_from_smc_x:
    lda sta_smc_x_l
    sta lda_smc_y_from_smc_x_l
    lda sta_smc_x_h
    sta lda_smc_y_from_smc_x_h
lda_smc_y_from_smc_x_l = * + 1
lda_smc_y_from_smc_x_h = * + 2
    lda $ffff,y
    rts
sta_smc_y:
sta_smc_y_l = * + 1
sta_smc_y_h = * + 2
    sta $ffff,y
    rts
lda_smc_y:
lda_smc_y_l = * + 1
lda_smc_y_h = * + 2
    lda $ffff,y
    rts

IP1_end = *

} ; !zn Phase1_Init

!if (* < (vmatrix + ROWS * COLS)) {
!error "main code under vmatrix"
}

; # main code and data

; # irq handler

irq:
    lda $9124   ; ACK IRQ
; DEBUG
!if DEBUG_IRQ_LEN > 0 {
    lda #$11
    sta $900f
}
    ldx flag_pause
    lda tbl_sound_volreg,x
    sta $900e
    bne +
    jmp irq_get_input
+   lda tbl_player_move_delay_counter
    beq +
    dec tbl_player_move_delay_counter
+   lda tbl_player_fire_delay_counter
    beq +
    dec tbl_player_fire_delay_counter
+   lda tbl_player_move_delay_counter + 1
    beq +
    dec tbl_player_move_delay_counter + 1
+   lda tbl_player_fire_delay_counter + 1
    beq +
    dec tbl_player_fire_delay_counter + 1
+
irq_sound:
    lda jiffy_lsb
    and #$01
    beq irq_sound_done
    ldx #$03
    stx irq_sound_loop_counter
irq_sound_loop:
    lda tbl_sound_fx,x
    beq irq_sound_next_loop
    cmp #SOUND_PLAYER_SHOOT
    bcc l1217
    bne l1202
    lda tbl_sound_state_counter,x  ; sound 5
    asl
    adc #60
    bne irq_sound_play
l1202:
    cmp #SOUND_7
    beq l120d
    lda tbl_sound_state_counter,x  ; sound 6
    asl
    adc #60
    bne irq_sound_play
l120d:
    lda tbl_sound_state_counter,x  ; sound 7
    clc
    adc #100
    bne irq_sound_play
l1217:
    tax  ; sound 1..4
    jsr rng
    and tbl_sound_freq_rand_mask,x
    clc
    adc tbl_sound_freq_base,x
    ldx irq_sound_loop_counter
irq_sound_play:
    cpx #2
    bne +
    lsr
+   ora #$80
    sta $900a,x
    dec tbl_sound_state_counter,x
    bne irq_sound_next_loop
irq_sound_stop:
    lda #$00
    sta tbl_sound_fx,x
    sta $900a,x
irq_sound_next_loop:
    dex
    dec irq_sound_loop_counter
    bpl irq_sound_loop
irq_sound_done:
    dec counter_star_anim
    bne l1277
    lda #$04
    sta counter_star_anim
    ldx star_anim_frame
    dex
    bpl l1265
    ldx #$02
l1265:
    stx star_anim_frame
    ldy tbl_star_anim_index,x
    ldx #$07
l126d:
    lda gfx_star_anim,y
    sta charset_gfx_star,x
    iny
    dex
    bpl l126d
l1277:
    dec player_input_delay_counter
    bne l1286
    lda #$01
    sta flag_player_input
    lda #$04
    sta player_input_delay_counter
l1286:
    dec move_bullets_delay_counter
    bne l1293
    lda #$01
    sta flag_move_bullets
    sta move_bullets_delay_counter
l1293:
    ldx spawn_delay_counter
    beq irq_get_input
    dex
    stx spawn_delay_counter

irq_get_input:
    inc jiffy_lsb

    lda #$00
    sta $9122
    lda #$ff
    sta $9121
    sta $9123

irq_get_input_player_1:
    lda $9111
    lsr
    tax
    and #$10    ; f
    sta irq_get_input_player_1_smc
    txa
    lsr
    and #$07    ; udl
irq_get_input_player_1_smc = * + 1
    ora #$00
    bit $9120   ; b7 = r
    bpl +
    ora #$08    ; r
+   sta tbl_player_input

irq_get_input_player_2:
    lda flag_pl2_userport_joy
    bne irq_read_pl2_userport

irq_read_pl2_keyboard:
    ldx #$ef
    stx $9121
    lda $9120
    lsr
    and #3
    tax
    lda tbl_read_pl2_keyboard,x
    sta read_pl2_smc
    lda $9120
    and #$20
    bne +
    lda read_pl2_smc
    ora #$02
    sta read_pl2_smc
+
    ldx #$df
    stx $9121
    lda $9120
    and #$04
    bne +
    lda read_pl2_smc
    ora #$08
    sta read_pl2_smc
+
    ldx #$fd
    stx $9121
    lda $9120
    and #$08
    bne +
    lda read_pl2_smc
    ora #$10
    sta read_pl2_smc
+
    lda $9120
    and #$20
read_pl2_smc = * + 1
    lda #$00
    eor #$1f
    jmp irq_read_pl2_done

tbl_read_pl2_keyboard:
!by $05, $04, $01, $00

irq_read_pl2_userport:
    ldx #0
    lda #$80
    sta $9112
    sta $9110
    lda $9110
    stx $9112

irq_read_pl2_done:
    sta tbl_player_input + 1

irq_get_input_done:
    lda #$f7
    sta $9120
    lda #$ff
    sta $9121
    sta $9122
    lda #$00
    sta $9123

    jsr $ff9f          ; read the keyboard

    ; end of irq
irq_exit:
; DEBUG
!if DEBUG_IRQ_LEN > 0 {
    lda #$08
    sta $900f
}

nmi:
    pla
    tay
    pla
    tax
    pla
    rti


; # data

text_title:
!pet $93, $1c, "crossroads"
!pet $05, "        "
!pet $9e, "1p"
!pet $1f, " ", $00

text_ingame_top:
!pet $13, $1c
!pet $1f, "000000", $9e, "0", $05, "0"
!pet $1c, " l00 "
!pet $1f, "000000", $9e, "0", $05, "0", 0

text_game_over:
!scr "game", $00, "over"

text_press_f7:
!scr "press", $00, "f7"

gfx_star_anim:
!by %........
!by %..##....
!by %...#..#.
!by %...####.
!by %.####...
!by %.#..#...
!by %....##..
!by %........

!by %........
!by %...##...
!by %....#...
!by %.####.#.
!by %.#.####.
!by %...#....
!by %...##...
!by %........

!by %........
!by %....##..
!by %.##..#..
!by %.#.##...
!by %...##.#.
!by %..#..##.
!by %..##....
!by %........


tbl_bitmask_rev:
!by $80, $40, $20, $10, $08, $04, $02
tbl_bitmask:
!by $01, $02, $04, $08, $10, $20, $40, $80
tbl_dir_to_move_x:
!by $00, $00, $01, $ff
tbl_dir_to_move_y:
!by $01, $ff, $00, $00
tbl_input_to_direction:
!by $00, $01, $02, $80, $00, $01, $03, $80, $00, $01, $80
tbl_level_monster_type:
tbl_level_monster_num = * + 1
!by $00, (36 * MONMUL) / MONDIV, $01, (25 * MONMUL) / MONDIV, $02, (15 * MONMUL) / MONDIV, $03, (12 * MONMUL) / MONDIV
!by $01, (34 * MONMUL) / MONDIV, $02, (10 * MONMUL) / MONDIV, $03, (16 * MONMUL) / MONDIV, $04, (20 * MONMUL) / MONDIV
!by $03, (24 * MONMUL) / MONDIV, $04, (16 * MONMUL) / MONDIV, $05, (24 * MONMUL) / MONDIV, $06, (16 * MONMUL) / MONDIV
!by $05, (19 * MONMUL) / MONDIV, $06, (18 * MONMUL) / MONDIV, $07, (20 * MONMUL) / MONDIV, $08, (15 * MONMUL) / MONDIV
tbl_monster_spawn_num:
!by (20 * MONMUL) / MONDIV, (15 * MONMUL) / MONDIV, (10 * MONMUL) / MONDIV
!by (9 * MONMUL) / MONDIV, (8 * MONMUL) / MONDIV, (7 * MONMUL) / MONDIV
!by (6 * MONMUL) / MONDIV,( 4 * MONMUL) / MONDIV, (5 * MONMUL) / MONDIV
tbl_rand_num_monster:
!by (16 * MONMUL) / MONDIV, (8 * MONMUL) / MONDIV, (4 * MONMUL) / MONDIV, (2 * MONMUL) / MONDIV
tbl_key_player_color:
!by $27, $2f
tbl_player_start_pos_x:
!by $01, AREA_W - 2
tbl_dir_to_char_offset:
!by $08, $0c, $00, $04
tbl_obj_data_index:
!by $00, OBJ_DATA_LEN, OBJ_DATA_LEN * 2, OBJ_DATA_LEN * 3
!by OBJ_DATA_LEN * 4, OBJ_DATA_LEN * 5, OBJ_DATA_LEN * 6, OBJ_DATA_LEN * 7
!by OBJ_DATA_LEN * 8, OBJ_DATA_LEN * 9, OBJ_DATA_LEN * 10, OBJ_DATA_LEN * 11
!by OBJ_DATA_LEN * 12, OBJ_DATA_LEN * 13, OBJ_DATA_LEN * 14
tbl_dir_opposite:
!by $01, $00, $03, $02
tbl_player_spawn_bullet_x_dir:
!by $02, $03
tbl_star_anim_index:
!by $00, $08, $10
tbl_player_score_index:
!by 0, 6
tbl_player_color:
!by $02, $05
tbl_obj_color_friend:
!by $ff, $ff, $ff, $05, $06, $03, $04, $ff, $09, $08, $ff, $ff, $ff, $ff, $ff, $ff
tbl_obj_type: ; index is char >> 4
!by $ff, $ff, $ff, $ff, $00, $01, $02, $03, $04, $05, $06, $07, $08, $09, $ff, $ff
; index 1..4
tbl_sound_freq_base:
!by $00, $33, $20, $50
; index 1..4
tbl_sound_freq_rand_mask:
!by $60, $0f, $3f, $1f, $0f
tbl_sound_volreg:
!by $08, $00
tbl_leveldata_offset:
!by $00, $00, LEVEL_SIZE * 1, LEVEL_SIZE * 2, LEVEL_SIZE * 3
tbl_colors_wall:
!by $02, $03, $04, $05, $06, $07, $01, $04

;   +- base char (tbl_obj_char)
;   |    +- bullet (tbl_bullet)
;   |    |    +- color | ?? (tbl_obj_color)
;   |    |    |    +- obj_pos_x_frac?? (tbl_obj_pos_x_frac)
;   |    |    |    |    +bcd score+ (tbl_obj_score_bcd_N)
;   |    |    |    |    |   10^N    |  +- hits (tbl_hits)
;   |    |    |    |    |           |  |    +- delay (tbl_obj_delay_value)
;   |    |    |    |    |           |  |    |    + vision | class/color << 4 (tbl_obj_vision)
;   |    |    |    |    |0    1    2|  |    |    |
tbl_obj_data_src:
!by $40, $7f, $86, $38, $05, $00, $00, $01, $05, $64  ; 0 : monster blue small
!by $50, $0a, $92, $21, $05, $01, $00, $01, $08, $27  ; 1 : monster red man
!by $60, $7f, $73, $10, $00, $03, $00, $02, $09, $36  ; 2 : monster cyan hmm
!by $70, $7f, $42, $18, $00, $04, $00, $03, $08, $88  ; 3 : monster brown lion *color was 8
!by $80, $7f, $75, $00, $00, $05, $00, $03, $07, $58  ; 4 : monster green ogg
!by $90, $7f, $77, $00, $00, $06, $00, $04, $06, $79  ; 5 : monster yellow chomp
!by $a0, $0e, $74, $62, $00, $00, $01, $03, $08, $ea  ; 6 : monster lblue bouncy *color was e
!by $b0, $0b, $85, $0b, $00, $01, $01, $02, $06, $9f  ; 7 : monster dbrown monkey *color was 9
!by $c0, $0d, $34, $63, $00, $05, $01, $03, $14, $4f  ; 8 : monster pink bouncy
!by $d0, $0a, $02, $20, $00, $00, $00, $03, $02, $01  ; 9 : player
!by $e0, $ff, $00, $20, $00, $00, $00, $01, $02, $01  ; a : bullet
!by $e0, $ff, $00, $20, $00, $00, $00, $01, $01, $01  ; b : bullet
!by $e0, $ff, $00, $10, $00, $00, $00, $10, $02, $01  ; c : bullet start
!by $f0, $0a, $40, $22, $02, $00, $00, $01, $07, $0e  ; d : monstrobullet 1
!by $f0, $7f, $60, $20, $02, $00, $00, $01, $04, $09  ; e : monstrobullet 2
;        +- bit 7: is_bullet?
;        +- bit 6-0: bullet type (3f = none)
;        +- bit 7-0: (if player bullet) player who shot it
;             +- bit 4: collects shields
;                  +- bit 7: half_char? do_ai_obj_x skipped if 0
;                  +- bit 6: bounce
;                  +- bit 5: can_bounce? takes_damage?
;                  +- bit 4: animation frame
;                  +- bit 3: erratic?
;                  +- bit 1-0: firing rate



; # routines

rng:
    lsr rng1
    ror rng0
    bcc +
    lda rng1
    eor #$b4
    sta rng1
+   lda rng0
    rts

rand_and_3:
    jsr rng
    and #$03
    rts

level_init:
    jsr rand_and_3
    clc
    adc #$3b
    cmp char_wall
    beq level_init
    sta char_wall
l0e1b:
    jsr rng
    and #$07
    tax
    lda tbl_colors_wall,x
    cmp color_wall
    beq l0e1b
    sta color_wall
    lda #$00
    sta flag_levelset
    ldx num_level_bcd_l
    lda num_level_bcd_h
    bne l0e3d
    cpx #$05
    bcc l0e52
l0e3d:
    jsr rand_and_3
    beq l0e45
    dec flag_levelset   ; -> $ff
l0e45:
    jsr rand_and_3
    tax
    inx
    cpx prev_rand_level
    beq l0e45
    stx prev_rand_level
l0e52:
    ldy #>tbl_leveldata_set0
    lda #<tbl_leveldata_set0
    bit flag_levelset
    bpl +
    ldy #>tbl_leveldata_set1
    lda #<tbl_leveldata_set1
+   clc
    adc tbl_leveldata_offset,x
    sta level_init_smc_l
    bcc +
    iny
+   sty level_init_smc_h
    lda #$00
    sta tmp_02
    sta tmp_03
    sta tmp_fd  ; X coord
    ldy #AREA_YOFF  ; Y coord
level_init_loop:
    ldx tmp_02
level_init_smc_l = * + 1
level_init_smc_h = * + 2
    lda tbl_leveldata_set0,x
level_init_get_tile:
    ldx tmp_03
    and tbl_bitmask_rev,x
    beq level_init_got_empty_tile
    lda char_wall
level_init_got_empty_tile = * + 1
    bit $20a9  ; lda #CHAR_EMPTY
    ldx tmp_fd  ; X coord
    jsr set_char_xy
    lda color_wall
    jsr set_color_xy
    inc tmp_03
    inc tmp_fd  ; X coord
    lda tmp_03
    cmp #$08
    bne level_init_next_tile
    lda #$00
    sta tmp_03
    inc tmp_02
level_init_next_tile:
    cpx #AREA_W - 1
    bne level_init_loop
level_init_next_line:
    lda #$00
    sta tmp_fd  ; X coord
    iny
    cpy #(AREA_H + AREA_YOFF)
    bne level_init_loop
    rts

draw_player_scores_lives_hits:
    ldx #$05
l0ecf:
    lda p1_score_bcd,x
    clc
    adc #$30
    sta screen_p1_score,x
    lda p2_score_bcd,x
    clc
    adc #$30
    sta screen_p2_score,x
    dex
    bpl l0ecf
draw_player_lives_hits:
    lda num_lives_p1
    clc
    adc #$30
    sta screen_p1_lives
    lda num_lives_p2
    clc
    adc #$30
    sta screen_p2_lives
    lda num_level_bcd_h
    clc
    adc #$30
    sta screen_level_h
    lda num_level_bcd_l
    clc
    adc #$30
    sta screen_level_l
draw_player_hits:
    lda tbl_hits
    clc
    adc #$30
    sta screen_p1_shield
    lda num_p2_hits
    clc
    adc #$30
    sta screen_p2_shield
    rts

set_char_xy:
    sta set_char_smc_v
    lda tbl_screen_line_addr_l,y
    sta set_char_smc_l
    lda tbl_screen_line_addr_h,y
    sta set_char_smc_h
set_char_smc_v = * + 1
    lda #$55
set_char_smc_l = * + 1
set_char_smc_h = * + 2
    sta vmatrix,x
    rts

get_char_xy:
    lda tbl_screen_line_addr_l,y
    sta get_char_smc_l
    lda tbl_screen_line_addr_h,y
    sta get_char_smc_h
get_char_smc_l = * + 1
get_char_smc_h = * + 2
    lda vmatrix,x
    rts

set_color_xy:
    sta sget_color_smc_v
    lda #OP_STA_ABS_X
    sta sget_color_smc_o
    bne +   ; bra
get_color_xy:
    lda #OP_LDA_ABS_X
    sta sget_color_smc_o
+   lda tbl_screen_line_addr_l,y
    sta sget_color_smc_l
    lda tbl_screen_line_addr_h,y
    clc
    adc #>(colorram - vmatrix)
    sta sget_color_smc_h
sget_color_smc_v = * + 1
    lda #$55
sget_color_smc_o:
sget_color_smc_l = * + 1
sget_color_smc_h = * + 2
    lda colorram,x
    rts

level_start:
    lda #$00
    tax
clear_tbl_hits_loop:
    sta tbl_hits,x
    inx
    bne clear_tbl_hits_loop
    sta num_extra_shields
    lda #$02
    sta l3fb6
    lda num_level_bcd_l
    and #$01
    beq init_monster_num
    inc num_level
init_monster_num:
    lda num_level
    sta counter_skip_obj_update
    ldx #$10
    stx tmp_obj_index
    dex
    stx obj_tbl_slot_prev
    ldx #$09
    stx largest_obj_tbl_slot
    lda #$00
init_monster_num_clear_loop:
    sta tbl_monster_num,x
    dex
    bpl init_monster_num_clear_loop
    ldx num_level_bcd_l
    lda num_level_bcd_h
    bne init_monster_num_hard
    cpx #$05
    bcc init_monster_num_easy
init_monster_num_hard:
    ldx #$09
l1319:
    jsr rand_and_3
    beq l1329
    tay
    lda tbl_rand_num_monster,y
    clc
    adc tbl_monster_spawn_num,x
    sta tbl_monster_num,x
l1329:
    dex
    bpl l1319
    jsr rng
    and #$07
    tax
    inx
    inx
    lda tbl_monster_num,x
    clc
    adc #(($20 * MONMUL) / MONDIV)
    sta tbl_monster_num,x
    bne init_monster_spawn
init_monster_num_easy:
    ldx #$00
    lda #$03
    sta tmp_fc
    lda num_level_bcd_l
    sec
    sbc #$01
    asl
    asl
    asl
    tay
l134f:
    lda tbl_level_monster_type,y
    tax
    lda tbl_level_monster_num,y
    sta tbl_monster_num,x
    iny
    iny
    dec tmp_fc
    bpl l134f
init_monster_spawn:
    lda #$00
    sta tmp_05
    jsr clear_to_draw_tbl
l1366:
    lda #SOUND_SPAWN
    tay
    jsr play_sound
    ldx tmp_05
    lda tbl_monster_num,x
    beq l13be
    dec tbl_monster_num,x
    jsr rand_empty_spot_xy
    lda #$00
    jsr set_color_xy
    jsr set_char_xy
    lda tmp_05
    jsr spawn_monster_a
    lda largest_obj_tbl_slot
    ldx tmp_03
    sta tbl_obj_slot_to_draw,x
    ldx largest_obj_tbl_slot
    jsr show_sprite_a
    inc tmp_03
    lda tmp_03
    cmp #$08
    bne l1366
    jsr init_monster_num_draw
    jmp l1366
init_monster_num_draw:
    lda spawn_delay_counter
    bne init_monster_num_draw
    ldx #$07
init_monster_num_draw_loop:
    lda tbl_obj_slot_to_draw,x
    beq init_monster_num_draw_next
    stx l00fe
    jsr draw_obj_a
    ldx l00fe
init_monster_num_draw_next:
    dex
    bpl init_monster_num_draw_loop
    jsr clear_to_draw_tbl
    rts

l13be:
    inc tmp_05
    lda tmp_05
    cmp #$09
    bne l1366
    jsr init_monster_num_draw
    lda num_lives_p1
    beq l13d2
    ldx #$00
    jsr spawn_player_x
l13d2:
    lda num_lives_p2
    beq l13db
    ldx #$01
    jsr spawn_player_x
l13db:
    lda #$05
    sta l00fe
l13df:
    jsr rand_empty_spot_xy
    lda #CHAR_SHIELD
    jsr set_char_xy
    lda #$01
    jsr set_color_xy
    dec l00fe
    bne l13df
l13f0:
    lda spawn_delay_counter
    bne l13f0
    jmp check_pause_key_f5

clear_to_draw_tbl:
    lda #$00
    sta tmp_03
    ldx #$07
l13fe:
    sta tbl_obj_slot_to_draw,x
    dex
    bpl l13fe
    rts

spawn_player_y:
    sty l000f
    lda #$0c
    sta tbl_bullet,y
    lda #$01
    jsr force_spawn_bullet_dir_a
    ldy l000f
    lda tbl_player_spawn_bullet_x_dir,y
    jsr force_spawn_bullet_dir_a
    ldy l000f
    lda #$0a
    sta tbl_bullet,y
    rts

; a = sound fx, SOUND_*
; y < 2 -> override
play_sound:
    ; check if noise
    cmp #6
    bcs play_noise
    cmp #2
    beq play_noise
    ; check override
    cpy #$02
    bcs l142e
    ldy #$01
    cmp #SOUND_PLAYER_SHOOT
    beq play_sound_do
    iny
    bne play_sound_do  ; bra
l142e:
    ldy tbl_sound_fx + 1
    beq play_sound_do
    ldy sound_fx_ch2 + 1
    bne play_sound_exit
    iny
play_sound_do:
    sta tbl_sound_fx,y
    lda #20
    sta tbl_sound_state_counter,y
play_sound_exit:
    rts
play_noise:
    cpy #$02
    bcc play_noise_do
    ldy sound_fx_ch4
    beq play_noise_do
    cpy #SOUND_SPAWN
    bne play_noise_exit
play_noise_do:
    sta sound_fx_ch4
    lda #20
    sta tbl_sound_state_counter + 3
play_noise_exit:
    rts

; a = object index
; tmp_fb = object char
; tmp_fc = object color
draw_obj_a:
    tax
; x = object index
draw_obj_x:
    lda tbl_obj_color,x
    sta tmp_fc
draw_obj_x_color_fc:
    lda tbl_dir_udrl,x
    tay
    lda tbl_dir_to_char_offset,y
    clc
    adc tbl_obj_char,x
    sta tmp_fb
    lda tbl_obj_pos_x_frac,x
    bpl l146e
    inc tmp_fb
l146e:
    lda tbl_obj_pos_x_frac,x
    and #$04
    beq l147b
    inc tmp_fb
    inc tmp_fb
    inc tmp_fb
l147b:
    stx tmp_03
    jsr draw_obj_x_tmp_color_char
    ldx tmp_03
    lda tbl_obj_pos_x_frac,x
    bpl l1493
    inc tmp_fb
draw_obj_x_other_half:
    jsr set_l7_l8_to_next_obj_x_pos
    ldx tmp_07
    ldy tmp_08
    jsr set_char_fb_color_fc_xy
l1493:
    rts

; x = object index
; tmp_fb = object char
; tmp_fc = object color
draw_obj_x_tmp_color_char:
    lda tbl_pos_y,x
    jsr limit_a_to_area_h_wrap
    tay
    lda tbl_pos_x,x
    jsr limit_a_to_area_w_wrap
    tax
set_char_fb_color_fc_xy:
    lda tmp_fc
    jsr set_color_xy
    lda tmp_fb
    jmp set_char_xy

; return:
; x = empty spot x
; y = empty spot y
; a = $20 (space)
rand_empty_spot_xy:
    jsr rng
    and #$1f
    cmp #AREA_W-1
    bcc +
    sbc #(AREA_W-1 - 3)
+   tax
    jsr rng
    and #$1f
    cmp #AREA_H-1-AREA_YOFF
    bcc +
    sbc #(AREA_H-1-AREA_YOFF - 3)
+   tay
    iny ; AREA_YOFF
-   jsr get_char_xy
    cmp #$20
    beq +
    inx
    cpx #AREA_W
    bne -
    ldx #0
    iny
    cpy #AREA_H + AREA_YOFF
    bne -
    ldy #AREA_YOFF
!if AREA_YOFF != 0 {
    bne -
} else {
    beq -
}
+   rts

show_sprite_a:
    lda #32
    sta spawn_delay_counter
    rts

spawn_monster_a:
    sta tmp_04
    tya
    pha
    txa
    pha
    jsr find_free_obj_tbl_slot_x
    lda tmp_04
    jsr copy_obj_data
    pla
    sta tbl_pos_x,x
    pla
    sta tbl_pos_y,x
    jsr rand_and_3
    sta tbl_dir_udrl,x
    jsr rng
    and #$07
    clc
    adc #$01
    sta tbl_obj_delay_counter,x
    rts

find_free_obj_tbl_slot_x:
    ldx #$10
find_free_obj_tbl_slot_x_loop:
    lda tbl_hits,x
    beq l15cf
    inx
    bne find_free_obj_tbl_slot_x_loop
find_free_obj_tbl_slot_not_found:
    ldx obj_tbl_slot_prev
    inx
    bne find_free_obj_tbl_slot_erase_old
    ldx #$10
find_free_obj_tbl_slot_erase_old:
    stx obj_tbl_slot_prev
    jsr erase_obj_x
    ldx obj_tbl_slot_prev
    jsr rand_spread_shields
    ldx obj_tbl_slot_prev
l15cf:
    cpx largest_obj_tbl_slot
    bcc l15d7
    stx largest_obj_tbl_slot
l15d7:
    rts

copy_obj_data:
    ldy #>tbl_obj_char
    sty obj_data_smc_dest_h
    tay
    lda tbl_obj_data_index,y
    tay
copy_obj_data_loop:
    lda tbl_obj_data_src,y
obj_data_smc_dest_h = * + 2
    sta tbl_obj_char,x
    iny
    inc obj_data_smc_dest_h
    lda obj_data_smc_dest_h
    cmp #>(tbl_obj_char + OBJ_DATA_LEN * $100)
    bne copy_obj_data_loop
    lda #$00
    sta tbl_shields,x
    lda #$01
    sta tbl_obj_delay_counter,x
    rts

erase_obj_x:
    lda #CHAR_EMPTY
    sta tmp_fb
    txa
    pha
    jsr draw_obj_x_tmp_color_char
    pla
    tax
    lda tbl_obj_pos_x_frac,x
    bpl l16a7
    jmp draw_obj_x_other_half
l16a7:
    rts

add_score_player_x_obj_y:
    stx l00fe
    lda tbl_player_score_index,x
    tax
    lda tbl_player_score_bcd_10p3,x
    sta tmp_fc
    lda tbl_player_score_bcd_10p0,x
    clc
    adc tbl_obj_score_bcd_10p0,y
    sta tbl_player_score_bcd_10p0,x
    lda tbl_player_score_bcd_10p1,x
    clc
    adc tbl_obj_score_bcd_10p1,y
    sta tbl_player_score_bcd_10p1,x
    lda tbl_player_score_bcd_10p2,x
    clc
    adc tbl_obj_score_bcd_10p2,y
    sta tbl_player_score_bcd_10p2,x
    jsr fix_score_bcd
    ldx l00fe
    ldy tbl_player_score_index,x
    lda tbl_player_score_bcd_10p3,y
    cmp tmp_fc
    beq skip_extra_life
extra_life_player_x:
    ldy num_lives_p1,x
    iny
    cpy #10
    bcc +
    ldy #9
+   sty num_lives_p1,x
skip_extra_life:
    jsr draw_player_scores_lives_hits
    rts

fix_score_bcd:
    ldx #$05
l16f1:
    lda p1_score_bcd,x
    cmp #$0a
    bcc l1703
    sec
    sbc #$0a
    sta p1_score_bcd,x
    dex
    inc p1_score_bcd,x
    inx
l1703:
    lda p2_score_bcd,x
    cmp #$0a
    bcc l1715
    sec
    sbc #$0a
    sta p2_score_bcd,x
    dex
    inc p2_score_bcd,x
    inx
l1715:
    dex
    bpl l16f1
    ldy #$00
    ldx #$00
l171c:
    lda p1_score_bcd,y
    cmp high_score_bcd,y
    bcc l1732
    beq l172b
l1726:
    sta high_score_bcd,y
    ldx #$01
l172b:
    iny
    cpy #$07
    bne l171c
    beq l1736
l1732:
    cpx #$01
    beq l1726
l1736:
    ldy #$00
    ldx #$00
l173a:
    lda p2_score_bcd,y
    cmp high_score_bcd,y
    bcc l1750
    beq l1749
l1744:
    sta high_score_bcd,y
    ldx #$01
l1749:
    iny
    cpy #$07
    bne l173a
    beq l1754
l1750:
    cpx #$01
    beq l1744
l1754:
    rts

update_obj_state:
    inc tmp_obj_index
    ldx tmp_obj_index
    cpx largest_obj_tbl_slot
    bcc l1765
    beq l1765
    ldx #$0f
    stx tmp_obj_index
    rts

l1765:
    lda tbl_hits,x
    beq update_obj_state
    dec tbl_obj_delay_counter,x
    bne update_obj_state
    lda tbl_obj_delay_value,x
    sta tbl_obj_delay_counter,x
    ldy #$03
    lda #$00
l1779:
    sta tbl_ai_dir_fire,y
    dey
    bpl l1779
    lda tbl_obj_pos_x_frac,x
    bpl do_ai_obj_x
    jmp redraw_obj_x

do_ai_obj_x:
    lda tbl_bullet,x
    bpl ai_monster_x

move_bullet:
    jsr get_char_next_pos_and_set_l7_l8
    ldx tmp_obj_index
    cmp #$40  ; monster base
    bcc move_bullet_check_empty
    jmp ai_coll_enemy
move_bullet_check_empty:
    cmp #CHAR_EMPTY
    bne move_bullet_hit_wall
    jmp ai_done
move_bullet_hit_wall:
    lda #$00
    sta tbl_hits,x
    jsr erase_obj_x
    rts

ai_monster_x:
    jsr ai_scan_target_obj_x
    ldy #$03
ai_monster_x_dir_loop:
    ldx tmp_obj_index
    lda tbl_ai_dir_obj_char,y
    cmp #CHAR_EMPTY
    beq ai_monster_x_next_dir
    cmp #$40  ; monster base
    bcs l17ce
    cmp #CHAR_SHIELD
    bne ai_monster_x_next_dir
    lda tbl_obj_color,x
    and #%00010000
    beq ai_monster_x_next_dir
    jsr ai_add_weight
ai_monster_x_next_dir:
    dey
    bpl ai_monster_x_dir_loop
    jmp ai_monster_dirs_done
l17ce:
    cmp #$e0  ; bullet base
    bcc l17ed
    lda tbl_obj_color,x
    and #%00100000
    bne ai_monster_x_next_dir
    jsr ai_sub_weight
    bne ai_monster_fire_rand  ; bra?
    lda tbl_obj_pos_x_frac,x
    and #%00010000
    beq ai_monster_fire_rand
    jsr ai_sub_weight
    jmp ai_monster_x_next_dir
    beq ai_monster_fire_rand  ; ??
l17ed:
    cmp #$d0  ; player base (or bullet)
    bcc l17f6
    lda #$00
    sta tbl_ai_dir_obj_color,y
l17f6:
    lda tbl_obj_vision,x
    tax
    lda tbl_ms4b,x
    cmp tbl_ai_dir_obj_color,y
    beq l1809
    tax
    lda tbl_ai_dir_obj_color,y
    cmp tbl_obj_color_friend,x
    bne l1820
l1809:
    ldx tmp_obj_index
    lda tbl_obj_pos_x_frac,x
    and #%00001000
    beq ai_monster_x_next_dir
    tya
    tax
    inc tbl_ai_dir_weight,x
    jsr ai_inc_rand_dir_weight
    jsr ai_inc_rand_dir_weight
    jmp ai_monster_x_next_dir
l1820:
    ldx tmp_obj_index
    lda tbl_obj_color,x
    bpl l182a
    jsr ai_sub_weight
l182a:
    lda tbl_obj_color,x
    and #$40
    beq ai_monster_fire_rand
    jsr ai_add_weight
ai_monster_fire_rand:
    lda tbl_obj_pos_x_frac,x
    and #$03
    sta tmp_03
    jsr rand_and_3
    sec
    sbc tmp_03
    sta tbl_ai_dir_fire,y
    jmp ai_monster_x_next_dir
ai_monster_dirs_done:
    ldx tmp_obj_index
    lda tbl_dir_udrl,x
    tax
    tay
    inc tbl_ai_dir_weight,x  ; prefer current dir
    ldx tbl_dir_opposite,y
    dec tbl_ai_dir_weight,x  ; discourage opposite dir
    jsr ai_inc_rand_dir_weight
ai_find_max_weight:
    jsr ai_inc_rand_dir_weight
    ldy #$03
    sty tmp_0e  ; max weight dir
    lda tbl_ai_dir_weight,y
    sta tmp_fd  ; max weight val
    dey
ai_find_max_weight_loop:
    lda tbl_ai_dir_weight,y
    cmp tmp_fd  ; max weight val
    bcc l1874
    beq ai_find_max_weight
    sta tmp_fd  ; max weight val
    sty tmp_0e  ; max weight dir
l1874:
    dey
    bpl ai_find_max_weight_loop
    ldy tmp_0e  ; max weight dir
    lda tbl_ai_dir_obj_dist,y
    cmp #1
    bne l188b
    lda tbl_ai_dir_obj_char,y
    cmp #CHAR_EMPTY
    beq l188b
    cmp #CHAR_SHIELD
    bcc ai_monster_dirs_done  ; char is wall, try again
l188b:
    ldy #$03
l188d:
    sty tmp_04
    cpy tmp_0e
    beq l1896
    jsr fire_bullet_dir_y
l1896:
    ldy tmp_04
    dey
    bpl l188d
    lda tmp_0e
    ldx tmp_obj_index
    cmp tbl_dir_udrl,x
    beq l18ad
    sta tbl_dir_udrl,x
    jsr draw_obj_x
    jmp fire_bullet_dir_0e
l18ad:
    ldy tmp_0e
    lda tbl_ai_dir_obj_dist,y
    cmp #$01
    bne ai_done
    lda tbl_ai_dir_obj_char,y
    cmp #CHAR_SHIELD
    bne l18cc
    inc tbl_shields,x
    inc tbl_hits,x
    lda #SOUND_SHIELD
    tay
    jsr play_sound
    jmp ai_done
l18cc:
    bcs ai_coll_object
    jmp ai_monster_dirs_done
ai_coll_object:
    ldx tmp_obj_index
    lda tbl_obj_vision,x
    tax
    lda tbl_ms4b,x
    cmp tbl_ai_dir_obj_color,y
    beq ai_coll_friend
    tax
    lda tbl_ai_dir_obj_color,y
    cmp tbl_obj_color_friend,x
    beq ai_coll_friend
ai_coll_enemy:
    ldx tmp_obj_index
    jsr move_obj_x_check_coll
    jsr check_hit_a_9
    ldx tmp_obj_index
    lda tbl_hits,x
    beq l1919
    ldx l000a
    lda tbl_hits,x
    beq ai_done
ai_coll_friend:
    ldx tmp_obj_index
    jsr toggle_obj_anim_frame
    jmp draw_obj_x
ai_done:
    ldx tmp_obj_index
    jsr l1ef3
    jmp fire_bullet_dir_0e

ai_add_weight:
    lda #40
    sec
    sbc tbl_ai_dir_obj_dist,y
    clc
    adc tbl_ai_dir_weight,y
    sta tbl_ai_dir_weight,y
l1919:
    rts

ai_sub_weight:
    lda #40
    sec
    sbc tbl_ai_dir_obj_dist,y
    sta tmp_03
    lda tbl_ai_dir_weight,y
    sec
    sbc tmp_03
    sta tbl_ai_dir_weight,y
    rts

; tmp_0e = dir
fire_bullet_dir_0e:
    ldy tmp_0e
; y = dir
fire_bullet_dir_y:
    lda tbl_ai_dir_fire,y
    bmi fire_bullet
    rts

fire_bullet:
    jsr find_free_obj_tbl_slot_x
    tya
    ldy tmp_obj_index
    jsr spawn_bullet_dir_a
    lda #SOUND_SPAWN
    tay
    jmp play_sound

ai_inc_rand_dir_weight:
    jsr rand_and_3
    tax
    inc tbl_ai_dir_weight,x
    rts

check_pause_key_f5:
    ldy key_code
    cpy #$37
    bne l1977
toggle_flag_pause:
    lda flag_pause
    eor #$01
    sta flag_pause
pause_get_time:
    lda jiffy_lsb
    clc
    adc #$0f
    sta tmp_fc
pause_wait_time_loop:
    lda jiffy_lsb
    cmp tmp_fc
    bne pause_wait_time_loop
l1977:
    lda flag_pause
    beq run_frame
    lda jiffy_lsb
    and #$01
    tax
    tya
    cmp tbl_key_player_color,x
    bne check_pause_key_f5
    lda num_lives_p1,x
    beq check_pause_key_f5
    lda tbl_player_color,x
    clc
    adc #1
    and #7
    bne +
    adc #1
+   sta tbl_player_color,x
    sta tbl_obj_color,x
    jsr draw_obj_x
    jmp pause_get_time

run_frame:
    lda flag_move_bullets
    beq l19a4
    jsr move_bullets
    lda flag_player_input
    bne get_player_input
l19a4:
    dec counter_skip_obj_update
    bne l19bb
    lda num_level
    sta counter_skip_obj_update
    lda jiffy_lsb
    sta tmp_fc
wait_frame_end:
    lda jiffy_lsb
    cmp tmp_fc
    beq wait_frame_end
    bne check_pause_key_f5

l19bb:
    jsr update_obj_state
    jsr rng
    cmp #$c8
    bcc skip_spawn_shield
    lda rng1
    cmp #1
    bne skip_spawn_shield
    lda num_extra_shields
    cmp #MAX_EXTRA_SHIELDS
    bcs skip_spawn_shield
spawn_shield:
    inc num_extra_shields
    jsr rand_empty_spot_xy
    lda #CHAR_SHIELD
    jsr set_char_xy
    lda #$01
    jsr set_color_xy
skip_spawn_shield:
    jmp check_pause_key_f5

get_player_input:
    lda #$00
    sta flag_player_input
    ldx #$01
    stx tmp_3a
get_player_input_loop:
    ldx tmp_3a
    lda num_lives_p1,x
    beq get_player_input_loop_next
    lda tbl_player_move_delay_counter,x
    bne get_player_input_loop_next
    jsr get_input_move_player_x
    jsr check_fire
get_player_input_loop_next:
    dec tmp_3a
    bpl get_player_input_loop
check_level_complete:
    lda tbl_shields
    clc
    adc num_p2_shields
    cmp #$05
    bcc check_game_over
    jmp l1e97
check_game_over:
    lda num_lives_p1
    bne l19a4
    lda num_lives_p2
    bne l19a4
    jmp print_game_over

get_input_move_player_x:
    lda tbl_player_input,x
    sta player_input
    stx tmp_05
    and #$0f
    sec
    sbc #$05
    tay
    lda tbl_input_to_direction,y
    sta tmp_04
    bmi draw_obj_l5
    lda tbl_dir_udrl,x
    cmp tmp_04
    bne l1a45
    lda tbl_obj_pos_x_frac,x
    bpl l1a7d
l1a3c:
    jsr redraw_obj_x
    rts

draw_obj_l5:
    ldx tmp_05
    jmp draw_obj_x

l1a45:
    lda tbl_dir_udrl,x
    tay
    sta tmp_06
    lda tbl_obj_pos_x_frac,x
    bmi l1a68
    ldy tmp_04
    jsr set_l7_l8_to_y_obj_x_pos
    jsr get_char_l7_l8
    ldx tmp_05
    cmp #$20
    beq l1a75
    cmp #$3f
    bcs l1a75
    lda tmp_06
    sta tmp_04
    bcc l1a7d
l1a68:
    lda tbl_dir_opposite,y
    cmp tmp_04
    bne l1a3c
    jsr set_l7_l8_to_next_obj_x_pos
    jsr set_obj_x_pos_to_l7_l8
l1a75:
    lda tmp_04
    sta tbl_dir_udrl,x
    jmp draw_obj_l5

l1a7d:
    jsr get_char_next_pos_and_set_l7_l8
    ldx tmp_05
    cmp #CHAR_EMPTY
    beq l1acd
    cmp #CHAR_SHIELD
    beq l1aa8
    cmp #CHAR_SHIELD  ; second cmp not needed
    bcc l1ac7
    stx l0009
    jsr obj_x_check_coll
    cpy #$02
    bcc l1ac7
    cpy #$10
    bcs l1aa5
    lda tbl_dir_udrl,y
    ldx tmp_3a
    cmp tbl_dir_udrl,x
    beq l1ac7
l1aa5:
    jmp check_hit_a_9
l1aa8:
    inc tbl_shields,x
    ldy #$01
    lda #SOUND_SHIELD
    jsr play_sound
    ldy tbl_hits,x
    iny
    cpy #10
    bcc l1abb
    dey
l1abb:
    tya
    sta tbl_hits,x
    jsr draw_player_hits
    jmp l1acd
    bne l1acd
l1ac7:
    jsr toggle_obj_anim_frame
    jmp draw_obj_l5
l1acd:
    ldx tmp_05
    jmp l1ef3

set_l7_l8_to_next_obj_x_pos:
    ldy tbl_dir_udrl,x
set_l7_l8_to_y_obj_x_pos:
    lda tbl_pos_x,x
    clc
    adc tbl_dir_to_move_x,y
    jsr limit_a_to_area_w_wrap
    sta tmp_07
    lda tbl_pos_y,x
    clc
    adc tbl_dir_to_move_y,y
    jsr limit_a_to_area_h_wrap
    sta tmp_08
    rts

limit_a_to_area_w_wrap:
    bpl +
    lda #AREA_W - 1
+   cmp #AREA_W
    bcc +
    lda #$00
+   rts

limit_a_to_area_h_wrap:
    cmp #AREA_YOFF - 1
    bne +
    lda #AREA_H + AREA_YOFF - 1
+   cmp #AREA_H + AREA_YOFF
    bne +
    lda #AREA_YOFF
+   rts

toggle_obj_pos_x_frac:
    lda tbl_obj_pos_x_frac,x
    eor #%10000000
    sta tbl_obj_pos_x_frac,x
    lda tbl_obj_pos_x_frac,x
    and #%11111011
    sta tbl_obj_pos_x_frac,x
    rts

kill_player_x:
    dec num_lives_p1,x
    lda #$03
    sta num_hits_p1,x
spawn_player_x:
    stx tmp_05
    lda num_lives_p1,x
    beq l1b7f
    lda #$09
    jsr copy_obj_data
    lda num_hits_p1,x
    sta tbl_hits,x
    lda tbl_player_color,x
    sta tbl_obj_color,x
    lda tbl_player_start_pos_x,x
    sta tbl_pos_x,x
    sta tmp_07
    lda #AREA_H - 2 + AREA_YOFF
    sta tbl_pos_y,x
    sta tmp_08
    lda tbl_player_spawn_bullet_x_dir,x
    sta tbl_dir_udrl,x
    jsr show_sprite_a
    ldx tmp_05
    lda #$28
    sta tbl_player_move_delay_counter,x
    jsr get_char_l7_l8
    ldx tmp_05
    cmp #CHAR_EMPTY
    beq l1b7a
    cmp #CHAR_SHIELD
    bne l1b66
    inc tbl_shields,x
    bne l1b7a
l1b66:
    stx l0009
    jsr obj_x_check_coll
    ldx l000a
    jsr erase_obj_x
    ldx l000a
    lda #$00
    sta tbl_hits,x
    jsr rand_spread_shields
l1b7a:
    ldy tmp_05
    jsr spawn_player_y
l1b7f:
    jmp draw_player_scores_lives_hits

ai_scan_target_obj_x:
    lda #$03
    sta tmp_fc
    stx tmp_05
    lda tbl_obj_vision,x
    and #$0f
    sta tmp_fd
    sta tmp_02
    ldy #$03
l1b91:
    lda #$00
    sta tbl_ai_dir_obj_dist,y
    lda #$64
    sta tbl_ai_dir_weight,y
    dey
    bpl l1b91
ai_scan_target_set_dir:
    ldx tmp_05
    lda tbl_pos_x,x
    sta tmp_03
    lda tbl_pos_y,x
    sta tmp_fb
ai_scan_target_in_dir_loop:
    ldy tmp_fc
    lda tmp_03
    clc
    adc tbl_dir_to_move_x,y
    jsr limit_a_to_area_w_wrap
    tax
    sta tmp_03
    lda tmp_fb
    clc
    adc tbl_dir_to_move_y,y
    jsr limit_a_to_area_h_wrap
    tay
    sta tmp_fb
    jsr get_char_xy
    ldy tmp_fc
    sta tbl_ai_dir_obj_char,y
    tya
    tax
    inc tbl_ai_dir_obj_dist,x
    lda tbl_ai_dir_obj_char,y
    cmp #$20
    bne ai_scan_target_found_obj
    dec tmp_fd
    bne ai_scan_target_in_dir_loop
ai_scan_target_found_obj:
    ; TODO use tbl_ms4b?
    lsr
    lsr
    lsr
    lsr
    tax
    lda tbl_obj_type,x
    bmi +
    tay
    ldx tbl_obj_data_index,y
    lda tbl_obj_data_src + OBJ_DATA_LEN - 1,x   ; get vision
    lsr
    lsr
    lsr
    lsr
    jmp ++
+   ldy tmp_fb
    ldx tmp_03
    jsr get_color_xy
    and #$0f
++  ldy tmp_fc
    sta tbl_ai_dir_obj_color,y
    dec tmp_fc
    bmi l1bf5
    lda tmp_02
    sta tmp_fd
    jmp ai_scan_target_set_dir
l1bf5:
    rts

print_game_over:
    ldx #$08
print_game_over_loop:
    lda text_game_over,x
    beq print_game_over_loop_next
    sta screen_loc_game_over,x
    lda jiffy_lsb
    ror
    and #7
    sta colorram_loc_game_over,x
print_game_over_loop_next:
    dex
    bpl print_game_over_loop
    jsr print_press_f7_check_f7
    beq l1c10
    jmp l19a4
l1c10:
    jmp init_start_screen

set_obj_x_pos_to_l7_l8:
    lda tmp_07
    sta tbl_pos_x,x
    lda tmp_08
    sta tbl_pos_y,x
    rts

move_bullets:
    ldx #$02
    lda #$00
    sta flag_move_bullets
move_bullets_loop:
    stx tmp_05
    lda tbl_hits,x
    beq move_bullets_loop_next
    lda tbl_obj_pos_x_frac,x
    bpl l1c3c
    jsr redraw_obj_x
    jmp move_bullets_loop_next
l1c3c:
    jsr get_char_next_pos_and_set_l7_l8
    ldx tmp_05
    cmp #CHAR_EMPTY
    beq l1c66
    cmp #$40  ; monster base
    bcs l1c55
    jsr erase_obj_x
    ldx tmp_05
    lda #$00
    sta tbl_hits,x
    beq move_bullets_loop_next
l1c55:
    jsr erase_obj_x
    ldx tmp_05
    jsr move_obj_x_check_coll
    jsr check_hit_a_9
    jsr l1c73
    jmp move_bullets_loop_next
l1c66:
    ldx tmp_05
    jsr l1ef3
move_bullets_loop_next:
    ldx tmp_05
    inx
    cpx #$10
    bne move_bullets_loop
    rts

l1c73:
    ldy l000a
    lda tbl_hits,y
    beq l1c7b
    rts
l1c7b:
    ldx tmp_05
    lda tbl_bullet,x
    tax
    jmp add_score_player_x_obj_y

move_obj_x_check_coll:
    stx l0009
    jsr set_l7_l8_to_next_obj_x_pos
obj_x_check_coll:
    ldy #$00
    ldx l0009
move_obj_x_check_coll_loop:
    sty l000a
    lda tbl_hits,y
    beq move_obj_x_check_coll_next
    lda tbl_pos_x,y
    sta l000b
    cmp tmp_07
    beq l1cb3
    lda tbl_obj_pos_x_frac,y
    bpl move_obj_x_check_coll_next
    lda tbl_dir_udrl,y
    tay
    lda l000b
    clc
    adc tbl_dir_to_move_x,y
    jsr limit_a_to_area_w_wrap
    cmp tmp_07
    bne move_obj_x_check_coll_next
l1cb3:
    ldy l000a
    lda tbl_pos_y,y
    sta l000b
    cmp tmp_08
    beq l1cd4
    lda tbl_obj_pos_x_frac,y
    bpl move_obj_x_check_coll_next
    lda tbl_dir_udrl,y
    tay
    lda l000b
    clc
    adc tbl_dir_to_move_y,y
    jsr limit_a_to_area_h_wrap
    cmp tmp_08
    bne move_obj_x_check_coll_next
l1cd4:
    cpx l000a
    beq move_obj_x_check_coll_next
    rts  ; collision happened, return normally
move_obj_x_check_coll_next:
    ldy l000a
    iny
    bne move_obj_x_check_coll_loop
; no collision
; unwind caller from stack
    pla
    pla
    rts

; tmp_3a = player num
check_fire:
    lda player_input
    and #$10
    beq +
    rts
+   ldy tmp_3a
    lda tbl_player_fire_delay_counter,y
    beq +
    rts
+   lda #SOUND_PLAYER_SHOOT
    jsr play_sound
    ldy tmp_3a
    lda #$0c
    sta tbl_player_fire_delay_counter,y
    lda tbl_dir_udrl,y
force_spawn_bullet_dir_a:
    sta l00fe
    sty tmp_05
    ldx #$02
l1d06:
    lda tbl_hits,x
    beq l1d27
    inx
    cpx #$10
    bne l1d06
    ldx l3fb6
    stx tmp_fd
    jsr erase_obj_x
    ldx l3fb6
    inx
    cpx #$10
    bne l1d22
    ldx #$02
l1d22:
    stx l3fb6
    ldx tmp_fd
l1d27:
    lda l00fe
    ldy tmp_05
    jsr spawn_bullet_dir_a
    rts

!if EXPR_BOUNCE_OVERLAP_FIX > 0 {
; TODO
; a) do not spawn monstrobullet that bounces
; b) do not erase if overlap/spawn (or: redraw not-dead object)
;    ; not good enough if the erase is after bounce
tmp_zz:
!by 0
}

; a = dir
; x = tmp_05 = bullet obj index
; y = tmp_fd = shooter obj index
spawn_bullet_dir_a:
    sta tbl_dir_udrl,x
    lda tbl_bullet,y
!if EXPR_BOUNCE_OVERLAP_FIX > 0 {
    sta tmp_zz
}
    stx tmp_05
    sty tmp_fd
    jsr copy_obj_data
    ldy tmp_fd
    lda tbl_obj_color,x
    and #$f0
    ora tbl_obj_color,y
    sta tbl_obj_color,x
    lda tbl_obj_vision,y
    and #$f0
    ora tbl_obj_vision,x
    sta tbl_obj_vision,x
    ldy tbl_dir_udrl,x
    ldx tmp_fd
    jsr set_l7_l8_to_y_obj_x_pos
    ldx tmp_05
    jsr set_obj_x_pos_to_l7_l8
    ldx tmp_fd
    lda tbl_obj_pos_x_frac,x
    bpl l1d65
    ldx tmp_05
    jsr set_l7_l8_to_next_obj_x_pos
    jsr set_obj_x_pos_to_l7_l8
l1d65:
    lda tmp_fd
    cmp #$02  ; num players
    bcs l1d70
    ldx tmp_05
    sta tbl_bullet,x
l1d70:
    jsr get_char_l7_l8
    ldx tmp_05
    cmp #CHAR_EMPTY
    beq l1da1
    cmp #$40  ; monster base
    bcs l1d83
-   lda #$00
    sta tbl_hits,x
l1d82:
    rts
l1d83:
    stx l0009
!if EXPR_BOUNCE_OVERLAP_FIX > 0 {
    ldy tmp_zz
    cpy #$d ; monstrobullet base
    bcc +
    and #$f0
    cmp #$c0    ; bouncer
    beq -
    cmp #$a0    ; bouncer
    beq -
+
}
    jsr obj_x_check_coll  ; exits this routine if no collision
    jsr check_hit_a_9
    ldx l000a
    lda tbl_hits,x
    bne l1da1
    ldx l0009
    lda tbl_bullet,x
    cmp #$02  ; num players
    bcs l1d82
    tax
    ldy l000a
    jmp add_score_player_x_obj_y
l1da1:
    jmp draw_obj_x

check_hit_a_9:
    ldy l000a
    lda tbl_obj_pos_x_frac,y
    and #%01000000
    beq hit_obj_a
    ldx l0009
    lda tbl_obj_pos_x_frac,x
    and #%00100000
    beq hit_obj_a
    lda tbl_dir_udrl,y
    tay
    lda tbl_dir_udrl,x
    cmp tbl_dir_opposite,y
    beq hit_obj_a
bounce_bullet:
    ldy tbl_dir_udrl,x
    lda tbl_dir_opposite,y
    sta tbl_dir_udrl,x
    lda #SOUND_BOUNCE
    ldx l0009
    ldy tbl_bullet,x
    jmp play_sound
hit_obj_a:
    ldx l000a
    dec tbl_hits,x
    jsr show_sprite_a
    ldx l0009
    lda tbl_obj_pos_x_frac,x
    and #%00100000
    beq l1deb
hit_obj_9:
    dec tbl_hits,x
l1deb:
    lda tbl_bullet,x
    bmi l1e10
    cmp #$02  ; num players
    bcs l1e04
    lda tbl_hits,x
    cmp #$02
    bcc l1e10
    ldx l000a
    lda #$00
    sta tbl_hits,x
    beq l1e10
l1e04:
    lda tbl_obj_pos_x_frac,x
    and #%00100000
    beq l1e10
    jsr show_sprite_a
l1e10:
    ldy #SOUND_3
    ldx l0009
    lda tbl_bullet,x
    bmi l1e1f
    cmp #$02
    bcc l1e1f
    ldy #SOUND_7
l1e1f:
    sty l000b
    ldx l000a
    lda tbl_hits,x
    bne l1e3a
    lda l000b
    cmp #SOUND_7
    beq l1e32
    lda #SOUND_2
    sta l000b
l1e32:
    jsr erase_obj_x
    ldx l000a
    jsr rand_spread_shields
l1e3a:
    ldx l0009
    lda tbl_hits,x
    bne check_hit_obj_9_is_player
    jsr erase_obj_x
    ldx l0009
    jsr rand_spread_shields
check_hit_obj_9_is_player:
    ldx l0009
    cpx #$02
    bcs check_hit_obj_a_is_player
    jsr draw_player_hits
    lda tbl_hits,x
    bne check_hit_obj_a_is_player
    jmp kill_player_x
check_hit_obj_a_is_player:
    ldx l000a
    cpx #$02
    bcs l1e72
    jsr draw_player_hits
    ldy #$01
    lda l000b
    jsr play_sound
    lda tbl_hits,x
    bne l1e79
    jmp kill_player_x
l1e72:
    ldy #$02
    lda l000b
    jsr play_sound
l1e79:
    rts

rand_spread_shields:
    lda tbl_shields,x
    sta l00fe
    lda #$00
    sta tbl_shields,x
l1e84:
    dec l00fe
    bmi l1e79
    jsr rand_empty_spot_xy
    lda #CHAR_SHIELD
    jsr set_char_xy
    lda #$01
    jsr set_color_xy
    bne l1e84
l1e97:
    ldx #$01
    stx tmp_3a
    lda #$04
    tax
    jsr copy_obj_data
l1ea1:
    ldx tmp_3a
    lda tbl_shields,x
    beq l1eb3
    dec tbl_shields,x
    ldy #$04
    jsr add_score_player_x_obj_y
    jmp l1ea1
l1eb3:
    dec tmp_3a
    bpl l1ea1
    ldx num_level_bcd_l
    inx
    cpx #$0a
    bcc l1ec4
    ldx #$00
    inc num_level_bcd_h
l1ec4:
    stx num_level_bcd_l
    jsr draw_player_scores_lives_hits
l1eca:
    jsr print_press_f7_check_f7
    bne l1eca
    jsr level_init
    lda tbl_hits
    sta num_hits_p1
    lda num_p2_hits
    sta num_hits_p2
    jmp level_start

redraw_obj_x:
    stx tmp_obj_index2
    jsr erase_obj_x
    ldx tmp_obj_index2
    jsr set_l7_l8_to_next_obj_x_pos
    jsr set_obj_x_pos_to_l7_l8
    jsr toggle_obj_pos_x_frac
    jsr draw_obj_x
    rts

l1ef3:
;    stx tmp_obj_index2
    jsr toggle_obj_pos_x_frac
    jsr draw_obj_x
;    ldx tmp_obj_index2
;    jsr draw_obj_x_color_fc  ; pointless?
    rts

toggle_obj_anim_frame:
    lda tbl_obj_pos_x_frac,x
    eor #$04
    sta tbl_obj_pos_x_frac,x
    rts

print_press_f7_check_f7:
    ldx #$07
l1f0c:
    lda text_press_f7,x
    beq l1f19
    sta screen_loc_press_f7,x
    lda #$01
    sta colorram_loc_press_f7,x
l1f19:
    dex
    bpl l1f0c
check_if_f7_pressed:
    lda key_code
!if 0 {
    jsr print_hex_a
}
    cmp #$3f
    rts


get_char_next_pos_and_set_l7_l8:
    jsr set_l7_l8_to_next_obj_x_pos
get_char_l7_l8:
    ldx tmp_07
    ldy tmp_08
    jsr get_char_xy
    rts

!if 0 {
; DEBUG
print_hex_a:
    pha
    pha
    and #$f
    tax
    lda hexchars,x
    sta vmatrix+1
    pla
    lsr
    lsr
    lsr
    lsr
    tax
    lda hexchars,x
    sta vmatrix+0
    pla
    rts
hexchars:
!scr "0123456789abcdef"
}

; # main code

init_phase2:
    lda #0
    sta flag_pause

init_start_screen:
    lda #$00
    ldx #$07
    stx tmp_obj_index
    stx largest_obj_tbl_slot
-   sta p1_score_bcd,x
    sta p2_score_bcd,x
    dex
    bpl -
    tax
-   sta tbl_hits,x
    sta tbl_shields,x
    inx
    bne -
    sta num_level_bcd_h
    lda #$01
    sta num_level_bcd_l
    sta num_level
    lda #<text_title
    ldy #>text_title
    jsr b_strout_ay
    ldx #5
-   lda high_score_bcd,x
    clc
    adc #$30
    sta screen_high_score,x
    dex
    bpl -
    lda old_num_players
    sta screen_num_players
    jsr level_init

!if DEBUG_OVERLAP > 0 {
    lda #$3f
    sta rng0
    lda #$fc
    sta rng1
    jmp dbg_init_spawn_start

m_init_type:
!by 8, 6, 7, 7
m_init_x:
!by 1, 2, 1, 2
m_init_y:   ; 0 -> done, >=$80 -> end
!by 2, 2, 3, 3, 0

dbg_init_spawn_start:
    ldx #0
-   stx tmp_05
    lda m_init_type,x
    sta tmp_06
    lda m_init_y,x
    beq dbg_init_spawn_end
    bpl +
    jsr rand_empty_spot_xy
    jmp ++
+   tay
    lda m_init_x,x
    tax
++  lda tmp_06
    jsr spawn_monster_a
    ldx largest_obj_tbl_slot
    jsr draw_obj_x
    ldx tmp_05
    inx
    bne -
dbg_init_spawn_end:
} else {
    ldx #$08
init_spawn_monsters:
    stx tmp_06
    lda tbl_monster_spawn_num,x
    sta tmp_05
init_spawn_monsters_loop:
    dec tmp_05
    bmi init_spawn_monsters_next_type
    jsr rand_empty_spot_xy
    lda tmp_06
    jsr spawn_monster_a
    ldx largest_obj_tbl_slot
    jsr draw_obj_x
    jmp init_spawn_monsters_loop
init_spawn_monsters_next_type:
    ldx tmp_06
    dex
    bpl init_spawn_monsters
}

    lda #(((vmatrix & $200) >> 2) | COLS)
    sta $9002

title_scroll_reset:
    ldx #$00
title_scroll_loop:
    ldy #$20 ;' '
    lda screen_num_players
    cmp #$31
    beq +
    ldy #$0b ;'k'
    bit flag_pl2_userport_joy
    bpl +
    ldy #$15 ;'u'
+   sty screen_pl2_input
    stx counter_title_scroll
l0c16:
    ldx counter_title_scroll
    lda counter_title_scroll
    and #$01
    beq +
    lda tbl_player_input
    and #$c ; left/right
    cmp #$c
    bne toggle_num_players
    lda tbl_player_input
    and #$3 ; up/down
    cmp #$3
    bne toggle_pl2_input
    lda tbl_player_input
    and #$10    ; fire
    bne +
    jmp game_init
toggle_pl2_input:
    lda flag_pl2_userport_joy
    eor #$ff
    sta flag_pl2_userport_joy
    jmp +
toggle_num_players:
    lda screen_num_players
    eor #3  ; $31 <-> $32
    sta screen_num_players
+   lda #$08
    sta counter_delay_jiffy
    lda #$00
    sta jiffy_lsb
    jsr check_spawn_keys
    ldx counter_title_scroll
    inx
    jmp title_scroll_loop

check_spawn_keys:
    ldx key_code
    lda k_tbl_keycode,x
!if 0 {
    jsr print_hex_a
}
    cmp #$31
    bcc l0ca1
    cmp #$3a
    bcs l0ca1
    sec
    sbc #$31
    pha
    jsr rand_empty_spot_xy
    pla
    jsr spawn_monster_a
l0ca1:
; DEBUG
!if DEBUG_IDLE_WAIT_INPUT > 0 {
    lda tbl_player_input
zdbg_step_mask = * + 1
    and #$1
    bne l0ca1
!if DEBUG_IDLE_WAIT_INPUT > 1 {
    lda zdbg_step_mask
    eor #3
    sta zdbg_step_mask
}
}
    jsr update_obj_state
    lda jiffy_lsb
    cmp counter_delay_jiffy
    bcc l0ca1
    rts

game_init:
    ldy #$04
    lda #$03
    sty num_lives_p1
    sta num_hits_p1
    ldx screen_num_players
    stx old_num_players
    cpx #$31
    bne l0dd7
    lda #$00
    tay
l0dd7:
    sty num_lives_p2
    sta num_hits_p2
    lda #<text_ingame_top
    ldy #>text_ingame_top
    jsr b_strout_ay
game_init_erase_objs:
    jsr draw_player_scores_lives_hits
    ldx #$00
    stx tmp_3a
game_init_erase_objs_loop:
    ldx tmp_3a
    lda tbl_hits,x
    beq l0e03
    jsr erase_obj_x
l0e03:
    inc tmp_3a
    bne game_init_erase_objs_loop
    jmp level_start

Main_end = *


; - levels

; 21*20 tiles
; 420/8 = 52.5 bytes

; nnnnnnn098765432109876543210 phase
;        0000000011111111nnnnn 0
;   222222223333333344444444nn 1
;      5555555566666666nnnnnnn 2
; 777777778888888899999999nnnn 3
;    AAAAAAAABBBBBBBBCCCCCCCCn 4
;       DDDDDDDDEEEEEEEEnnnnnn 5
;  FFFFFFFFGGGGGGGGHHHHHHHHnnn 6
;     IIIIIIIIJJJJJJJJKKKKKKKK 7

!macro lvldatab {
!set LEVELDATABITS = 0
!set LEVELDATATMP = 0
}

!macro lvldatad .v {
!by (LEVELDATATMP << (8 - LEVELDATABITS)) | (.v >> (21 - 8 + LEVELDATABITS)) & ((1 << (8 - LEVELDATABITS)) - 1)
!set LEVELDATABITS = 21 - (8 - LEVELDATABITS)
!do while LEVELDATABITS >= 8 {
    !by (.v >> (LEVELDATABITS - 8)) & $ff
    !set LEVELDATABITS = LEVELDATABITS - 8
}
!set LEVELDATATMP = (.v & ((1 << LEVELDATABITS) - 1))
}

!macro lvldatae {
!by (LEVELDATATMP << (8 - LEVELDATABITS))
}

tbl_leveldata_set0:
!if DEBUG_OVERLAP > 0 {
; test lev 098765432109876543210
+lvldatab
+lvldatad %########..########### ; 0
+lvldatad %#..#................# ; 1
+lvldatad %#..#................# ; 2
+lvldatad %####................# ; 3
+lvldatad %..................... ; 4
+lvldatad %..................... ; 5
+lvldatad %..................... ; 6
+lvldatad %......#####.......... ; 7
+lvldatad %..........#.......... ; 8
+lvldatad %..........#.......... ; 9
+lvldatad %..........####....... ; 10
+lvldatad %..................... ; 11
+lvldatad %..................... ; 12
+lvldatad %..................... ; 13
+lvldatad %..................... ; 14
+lvldatad %..................... ; 15
+lvldatad %..................... ; 16
+lvldatad %..................... ; 17
+lvldatad %#...................# ; 18
+lvldatad %########..########### ; 19
+lvldatae
}

!if 0 {
; test lev 098765432109876543210
+lvldatab
+lvldatad %########..########### ; 0
+lvldatad %#...................# ; 1
+lvldatad %#...................# ; 2
+lvldatad %#...................# ; 3
+lvldatad %..................... ; 4
+lvldatad %..................... ; 5
+lvldatad %..................... ; 6
+lvldatad %......#####.......... ; 7
+lvldatad %..........#.......... ; 8
+lvldatad %..........#.......... ; 9
+lvldatad %..........####....... ; 10
+lvldatad %..................... ; 11
+lvldatad %..................... ; 12
+lvldatad %..................... ; 13
+lvldatad %..................... ; 14
+lvldatad %..................... ; 15
+lvldatad %..................... ; 16
+lvldatad %..................... ; 17
+lvldatad %#...................# ; 18
+lvldatad %########..########### ; 19
+lvldatae
}

+lvldatab
+lvldatad %########.###.########
+lvldatad %#......#.....#......#
+lvldatad %#.###....###....###.#
+lvldatad %#.#....#.....#....#.#
+lvldatad %..#.####.###.####.#..
+lvldatad %#...#...........#...#
+lvldatad %#.#.#...........#.#.#
+lvldatad %#...#...........#...#
+lvldatad %#.###...........###.#
+lvldatad %..#...............#..
+lvldatad %#...#...........#...#
+lvldatad %###.#...........#.###
+lvldatad %#...#...........#...#
+lvldatad %#...#...........#...#
+lvldatad %#.######.###.####.#.#
+lvldatad %.....................
+lvldatad %#.#..###.###.###..#.#
+lvldatad %#.##...#.....#...##.#
+lvldatad %#....#....#....#....#
+lvldatad %########.###.########
+lvldatae

+lvldatab
+lvldatad %#######.#####.#######
+lvldatad %....#...........#....
+lvldatad %#.#...#.##.##.#...#.#
+lvldatad %....#...........#....
+lvldatad %##.####.#####.####.##
+lvldatad %.....................
+lvldatad %##.##.....#.....##.##
+lvldatad %#...#.....#.....#...#
+lvldatad %#.#.#.....#.....#.#.#
+lvldatad %..........#..........
+lvldatad %#.#.#...#####...#.#.#
+lvldatad %#.#.#.#...#...#.#.#.#
+lvldatad %#.###.#.#.#.#.#.###..
+lvldatad %.....................
+lvldatad %##.####.#####.###.###
+lvldatad %#...................#
+lvldatad %#.#...#.......#.###.#
+lvldatad %#.###.............#.#
+lvldatad %#.....#........#....#
+lvldatad %#######.#####.#######
+lvldatae

+lvldatab
+lvldatad %#######.#####.#######
+lvldatad %#........#.#........#
+lvldatad %#..#.........#......#
+lvldatad %##.#######.######.#.#
+lvldatad %#...#...........#...#
+lvldatad %#.###...........#...#
+lvldatad %#...#...........#.#.#
+lvldatad %.....................
+lvldatad %#.#.#...........#.#.#
+lvldatad %#.#.#...........#.#.#
+lvldatad %....#...........#....
+lvldatad %#.###...........###.#
+lvldatad %#...######.######...#
+lvldatad %##.................##
+lvldatad %#...###.##.#..#.##..#
+lvldatad %#.#.#....#......#...#
+lvldatad %#.#...#....#..#...#.#
+lvldatad %#.###.#.#####.#.###.#
+lvldatad %#.....#.......#.....#
+lvldatad %#######.#####.#######
+lvldatae

+lvldatab
+lvldatad %##.###.###.###.###.##
+lvldatad %#....#.........#....#
+lvldatad %#.##.#.#.###.#.#.##.#
+lvldatad %..#....#.....#....#..
+lvldatad %#.#.##.#.###.#.##.#.#
+lvldatad %#......#.....#......#
+lvldatad %####.#.#.#.#.#.#.####
+lvldatad %.....................
+lvldatad %.....#.#.#.###.#.....
+lvldatad %.....#.#.....#.#.....
+lvldatad %.....#.#.###.#.#.....
+lvldatad %.....................
+lvldatad %#.##.#.#######.#.##.#
+lvldatad %#...................#
+lvldatad %###.#....#.#....#.###
+lvldatad %#...##.###.###.##...#
+lvldatad %#...................#
+lvldatad %#.#.##.###.###.##.#.#
+lvldatad %#...#...........#...#
+lvldatad %##.###.###.###.###.##
+lvldatae

tbl_leveldata_set1:
+lvldatab
+lvldatad %####.##.#####.##.####
+lvldatad %#.......#...#.......#
+lvldatad %#.###.#...#...#.###.#
+lvldatad %........#...#........
+lvldatad %#.#.#.#.#####.#.#.#.#
+lvldatad %#...................#
+lvldatad %#...#...#...#...#...#
+lvldatad %..#.#...#...#...#.#..
+lvldatad %#.#.#...#...#...#.#.#
+lvldatad %....#.#########.#....
+lvldatad %###.#...#...#...#.###
+lvldatad %....#...#...#...#....
+lvldatad %#...#...........#.#.#
+lvldatad %#.#.#.########..#...#
+lvldatad %#.#...............#.#
+lvldatad %#.#.##.#.#.#.#.##.#.#
+lvldatad %#...#..#.....#......#
+lvldatad %#.#.#....###.#.#.#..#
+lvldatad %#.....#........#....#
+lvldatad %####.##.#####.##.####
+lvldatae

+lvldatab
+lvldatad %#####.###.#.###.#####
+lvldatad %#.....#...#...#.....#
+lvldatad %#.###.#.#.#.#.#.###.#
+lvldatad %#.#...#...#...#...#.#
+lvldatad %..#.###.#.#.#.###.#..
+lvldatad %#.#...#...#...#...#.#
+lvldatad %#.###.#.#.#.#.#.###.#
+lvldatad %#.....#.#.#.#.#.....#
+lvldatad %#######.#.#.#.#######
+lvldatad %#.....#.#.#.#.#.....#
+lvldatad %#.#.#...#.#.#...#.#.#
+lvldatad %#...#.###.#.###.#...#
+lvldatad %##.##.#...#...#.##.##
+lvldatad %##.#..#.#.#.#.#..#.##
+lvldatad %#.......#.#.#.......#
+lvldatad %#.#.###.#.#.#.###.#.#
+lvldatad %#...#.....#.....#...#
+lvldatad %#.#.#.###.#.###.#.#.#
+lvldatad %#...#.#...#...#.#...#
+lvldatad %#####.###.#.###.#####
+lvldatae

+lvldatab
+lvldatad %##.###.##.#.##.###.##
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.#.....#.....#.....#.
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %....#...........#....
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.#.....#.....#.....#.
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %.....................
+lvldatad %....#...........#....
+lvldatad %#.........#.........#
+lvldatad %##.###.##.#.##.###.##
+lvldatae

+lvldatab
+lvldatad %####.#####.#####.####
+lvldatad %#..#.#.........#.#..#
+lvldatad %#..#.#.#######.#.#..#
+lvldatad %#...................#
+lvldatad %#.#.##.###.###.##.#.#
+lvldatad %.....................
+lvldatad %.........###.........
+lvldatad %.......#.....#.......
+lvldatad %.....#...###...#.....
+lvldatad %.......#.........#...
+lvldatad %...#.........#.......
+lvldatad %.....#...###...#.....
+lvldatad %.......#.....#.......
+lvldatad %.........###.........
+lvldatad %.....................
+lvldatad %#.##.#.#######.#.##.#
+lvldatad %#....#.........#....#
+lvldatad %#.####.#######.####.#
+lvldatad %#......#.....#......#
+lvldatad %####.#####.#####.####
+lvldatae

leveldata_end = *

!if * > Data_large_start {
!error "main over large data"
}
